package jsphome.user;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

// ȸDAO ü
public class UserDAO {
	Connection conn = null;
	PreparedStatement pstmt = null;
	ResultSet rs = null;

	String jdbc_driver = "com.mysql.cj.jdbc.Driver";
	String jdbc_url = "jdbc:mysql://127.0.0.1:3306/jsphomedb";

	// DB  ޼ҵ
	void connect() {
		try {
			Class.forName(jdbc_driver);
			conn = DriverManager.getConnection(jdbc_url, "sch", "1234");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	// DB   ޼ҵ
	void disconnect() {
		if (rs != null) {
			try {
				rs.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		if (pstmt != null) {
			try {
				pstmt.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		if (conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}

	// α 
	public boolean login(String uid, String password) {
		connect();

		String sql = "select * from User where uid=? and password=?"; // id password ġ  Ȯ sql

		try {
			//  ڸ ϱ  PreparedStatement 
			pstmt = conn.prepareStatement(sql);
			// id  password 
			pstmt.setString(1, uid);
			pstmt.setString(2, password);
			rs = pstmt.executeQuery(); //    rs 

			if (rs.next()) { //    
				return true; // α , true ȯ
			} else { //  
				return false; // α , false ȯ
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}
		return false;
	}

	// ȸ 
	public boolean register(User user) {
		connect();

		String sql = "insert into User values(?, ?, ?, ?, ?)";

		try {
			pstmt = conn.prepareStatement(sql);
			// ?  ȸ  
			pstmt.setString(1, user.getUid());
			pstmt.setString(2, user.getPassword());
			pstmt.setString(3, user.getName());
			pstmt.setString(4, user.getEmail());

			java.util.Date utilDate = new java.util.Date();
			java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());
			pstmt.setDate(5, sqlDate); //  ȸϴ ¥ 
			pstmt.executeUpdate(); //  
			return true; // ϸ true ȯ
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}
		return false;
	}
}
