<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>

<!-- 게시글 관련 빈즈 객체 -->
<jsp:useBean id="bdao" class="jsphome.board.BoardDAO" />
<jsp:useBean id="board" class="jsphome.board.Board" />
<jsp:setProperty name="board" property="*" />

<%
	int bid = Integer.parseInt(request.getParameter("bid")); // 받아온 게시글 번호
	board = bdao.getBoard(bid); // 게시글 객체를 받아 board에 저장
	String uid = board.getUid(); // 게시글의 작성자
	String subject = board.getSubject(); // 제목
	String content = board.getContent(); // 내용
%>

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>board.jsp</title>
</head>
<script>
	// 게시글 삭제 확인 여부 함수
	function delete_check(url) {
		var answer;
		answer = confirm("정말로 삭제하시겠습니까?"); // true 또는 false를 반환
		if (answer) { // 확인을 선택한 경우 (true)
			location = url; // 매개변수로 받은 url로 이동
		}
	}
</script>
<body>
	<div align=center>
		<h2>게시판</h2>
		<hr>
		<form method="post" action="board_modify_form.jsp?bid=<%=bid%>">
			<table border="1">
				<tr>
					<td>글번호 : <input type="hidden" name="bid" value="<%=bid%>"><%=bid%></td>
				</tr>
				<tr>
					<td>작성자 : <input type="hidden" name="uid" value="<%=uid%>"><%=uid%></td>
				</tr>
				<tr>
					<td>제목 &nbsp;&nbsp;&nbsp;&nbsp;: <input type="hidden"
						name="subject" value="<%=subject%>"><%=subject%></td>
				</tr>
				<tr>
					<td colspan="2">내용
						<p>
							<textarea name="content" cols="30" rows="10" readonly><%=content%></textarea>
						</p>
					</td>
				</tr>
				<tr>
					<td colspan="2">
						<%
							// 해당 게시글의 작성자인 경우 수정 가능
							if (session.getAttribute("suid").equals(uid)) { 
						%><input type="submit" value="수정"> <a
						href="javascript:delete_check('controller.jsp?action=delete_board&bid=<%=bid%>')">삭제</a>
						<%
							}
						%> <a href="home.jsp">목록</a>
					</td>
				</tr>
			</table>
		</form>
	</div>
</body>
</html>