<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%
	request.setCharacterEncoding("UTF-8"); // 파라미터로 한글을 받기 위해 설정
String action = request.getParameter("action"); // 요청 action
String bid = request.getParameter("bid"); // 실제 글번호
%>

<!-- 회원 관련 빈즈 객체 -->
<jsp:useBean id="udao" class="jsphome.user.UserDAO" />
<jsp:useBean id="user" class="jsphome.user.User" />
<jsp:setProperty name="user" property="*" />

<!-- 게시글 관련 빈즈 객체 -->
<jsp:useBean id="bdao" class="jsphome.board.BoardDAO" />
<jsp:useBean id="board" class="jsphome.board.Board" />
<jsp:setProperty name="board" property="*" />

<%
// 회원가입
if (action.equals("register")) {
	if (udao.register(user)) {
		response.sendRedirect("home.jsp");
	} else {
		out.println("<script> alert('회원가입에 실패하였습니다.!!'); history.go(-1); </script>");
	}
}

// 로그인
if (action.equals("login")) {
	if (udao.login(user.getUid(), user.getPassword())) {
		session.setAttribute("suid", user.getUid()); // 로그인 유지를 위해 세션에 로그인한 id 저장
		response.sendRedirect("home.jsp");
	} else {
		out.println("<script> alert('아이디 또는 비밀번호가 틀렸습니다.!!'); history.go(-1); </script>");
	}
}

// 로그아웃
if (action.equals("logout")) {
	session.setAttribute("suid", null); // 세션 id 해제
	response.sendRedirect("home.jsp");
}
%>


<%
// 게시글 상세보기
	if (action.equals("board")) {
	pageContext.forward("board.jsp"); // 게시글 화면으로 파라미터를 넘김
}

// 게시글 등록
if (action.equals("insert_board")) {
	if (bdao.insertBoard(board)) {
		response.sendRedirect("home.jsp");
	} else {
		out.println("<script> alert('게시글 등록 실패!!'); history.go(-1); </script>");
	}
}

// 게시글 수정
if (action.equals("update_board")) {
	if (bdao.updateBoard(board)) {
		response.sendRedirect("board.jsp?bid=" + bid); // 수정된 게시글 상세보기 페이지로 이동
	} else {
		out.println("<script> alert('게시글 수정 실패!!'); history.go(-1); </script>");
	}
}

// 게시글 삭제
if (action.equals("delete_board")) {
	if (bdao.deleteBoard(bid)) {
		response.sendRedirect("home.jsp");
	} else {
		System.out.println("게시글 삭제 실패");
		out.println("<script> alert('게시글 삭제 실패!!'); history.go(-1); </script>");
	}
}
%>